#include "game.h"
#include<stdio.h>
#include<stdlib.h>
#include<stdbool.h>
#include<time.h>
#include"piece.h"
#include<string.h>

piece* creat_tab(int i){
  srand(time(NULL));
  bool inter = false;
  piece* pieces = malloc(sizeof(piece)*(i));
  int j = 1;
  *pieces = new_piece_rh(rand()%3, 3, true, true);
  while(j<i){
    if(rand()%2){
      if(rand()%2){
        *(pieces+j) = new_piece_rh(rand()%5, rand()%5, true, true);
      }
      else{
	*(pieces+j) = new_piece_rh(rand()%5, rand()%5, true, false);
      }
    }
    else{
      if(rand()%2){
	*(pieces+j) = new_piece_rh(rand()%4, rand()%5, false, true);
      }
      else{
        *(pieces+j) = new_piece_rh(rand()%5, rand()%4, false, false);  
      }
    }
    for(int k = 0; k<j; k++){
      if(intersect(*(pieces+j), *(pieces+k))){
	  inter = true;
      }
    }
    if(!inter){
      j++;
    }
    inter = false;
  }
  return pieces;
}

void display(game g){
  int **t;
  t = malloc(sizeof(*t)*6);
  for(int h = 0 ; h<6; h ++){
    t[h]= malloc(sizeof(*(t[h]))*6);
  }
  for(int x = 0; x<6; x++){
    for(int y = 0; y<6; y++){
      t[x][y] = -1;
    }
  }
  for(int k = 0; k<game_nb_pieces(g); k++){
    for(int x = 0; x<6; x++){
      for(int y = 0; y<6; y++){
        if(get_x(game_piece(g,k)) == x && get_y(game_piece(g,k)) == y){
	  for(int i = x; i-x < get_width(game_piece(g,k)); i++){
            for(int j = y; j-y < get_height(game_piece(g,k)); j++){
              t[i][j] = k;
	    }
	  }
	}
      }
    }
  }
  printf("########\n");
  for(int y = 5; y>=0; y--){
    printf("#");
    for(int x = 0; x<6; x++){
      if(t[x][y] == -1){
        printf(".");
      }
      else{
        printf("%d",t[x][y]);
      }
    }
    if(y == 3){
      printf("\n");
    }
    else{
      printf("#\n");
    }
  }
  printf("########\n");
  for(int h = 0 ; h<6; h ++){ 
    free(t[h]);
  }
  free(t);
}

int main(){
  piece* tab_pieces = malloc(sizeof(*tab_pieces)*10);
  if(tab_pieces == NULL){
    return 1;
  }
  char* i = malloc(sizeof(*i)*10);
  if(i == NULL){
    return 1;
  }
  bool end = false;
  char* direction = malloc(sizeof(*direction)*10);
  if(direction == NULL){
    return 1;
  }
  char* piece = malloc(sizeof(*piece)*10);
  if(piece == NULL){
    return 1;
  }
  char* distance = malloc(sizeof(*direction)*10);
  if(distance == NULL){
    return 1;
  }
  dir v;
  printf(" _____                                                       \n");
  printf("|  _  |             _             _                         \n");
  printf("| |_| |            | |           | |                        \n");
  printf("|    _| _   _  ___ | |__         | |__    ___   _   _  _ __ \n");
  printf("|   |  | | | || __||  _ |   ___  |  _ |  | _ | | | | || | _|\n");
  printf("| || | | |_| ||__ || | | | |___| | | | || |_| || |_| ||  |  \n");
  printf("|_| |_| |___| |___||_| |_|       |_| |_| |___|  |___| |_|   \n\n");
  printf("  ____                                                       \n");
  printf(" | ___|  \n");
  printf("| |      \n");
  printf(" | |_   _   _  ____    ___   _ __         ___  _        _   ____   ____   ____\n");
  printf("  |_ | | | | ||  _ |  | _ | | | _|  ___  | __|| |  __  | | |__  | |__  | | _  |\n");
  printf(" ___| || |_| || |_| || |_|_||  |   |___| |__ | | ||  || | | |_| || |_| || |_| |\n");
  printf("|____|  |___| |  __|  |____||_|          |___|  |__||__|   |____| |____| |__  |\n");
  printf("              | |                                                          _| |\n");
  printf("              |_|                                                         |___|\n");  
  printf("    \n");
  while(true){
    end = false;
    printf("\nCombien de pièces ? -> ");
    scanf("%c",i);
    while(atoi(i)<=0 || atoi(i)>10){
      printf("Taille incorrecte !\n");
      printf("\nVeuillez entrer un nouveau nombre: -> ");
      scanf("%c",i);
    }
    tab_pieces = creat_tab(atoi(i));
    game g = new_game_hr(atoi(i), tab_pieces);
    printf("\n\n\n\n\n\n\n");
    display(g);
    printf("\n\n\n\n\n\n\n");
    while(!game_over_hr(g) && !end){
      printf("Nombre de mouvements: %d\n", game_nb_moves(g));
      printf("\nChoisissez une pièce: -> ");
      scanf("%s",piece);
      if(strcmp(piece,"q")!=0){
	printf("\n\n\n\n\n\n\n");
	display(g);
	printf("\n\n\n\n\n\n\n");
	printf("Nombre de mouvements: %d\n", game_nb_moves(g));
        printf("\nChoisissez sa direction: -> ");
        scanf("%s",direction);
	if(strcmp(piece,"q")!=0){
	  printf("\n\n\n\n\n\n\n");
	  display(g);
	  printf("\n\n\n\n\n\n\n");
	  printf("Nombre de mouvements: %d\n", game_nb_moves(g));
	  printf("\nDe combien de cases ? -> ");
	  scanf("%s",distance);
	  printf("%s\n",direction);
	  if(strcmp(distance,"q") != 0){
	    if(!strcmp(direction,"RIGHT")){
	      v =RIGHT;
	      printf("%d\n",atoi(piece));
	      play_move(g,atoi(piece),v,atoi(distance));
	    }
	    if(!strcmp(direction,"LEFT")){
	      v =LEFT;
	      play_move(g,atoi(piece),v,atoi(distance));
	    }  
	    if(!strcmp(direction,"UP")){
	      v =UP;
	      play_move(g,atoi(piece),v,atoi(distance));
	    }
	    if(!strcmp(direction,"DOWN")){
	      v =DOWN;
	      play_move(g,atoi(piece),v,atoi(distance));
	    }
	    printf("\n\n\n\n\n\n\n");
	    display(g);
	    printf("\n\n\n\n\n\n\n");
	  }
	  else{
            end = true;
	  }
	}    
	else{
          end = true;
	}
      }
      else{
        end = true;
      }
    }
    if(game_over_hr(g)){
      printf("\nC'est gagné !!\n");
    }
    else{
      printf("\nDéjà marre ?\n");
    }
    delete_game(g);
    for(int o = 0; o <= atoi(i); o++){
	delete_piece(tab_pieces[o]);
    }
    printf("Une nouvelle partie ? y/n -> ");
    char* reponse = malloc(sizeof(*direction)*10);
    if(reponse == NULL){
      return 1;
    }
    scanf("%s",reponse);
    if(!strcmp(reponse,"n")){
      free(direction);
      free(distance);
      free(piece);
      free(i);
      free(reponse);
      free(tab_pieces);
      return 0;
    }
  }
}
